Codeforces Round 481 (Div. 3)

2024-02-02 03:44
文章标签 codeforces round div 481

本文主要是介绍Codeforces Round 481 (Div. 3),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

本场比赛也是没有考察什么算法重点在于思维模式

目录

A. Remove Duplicates

B. File Name

C. Letters

D. Almost Arithmetic Progression

E. Bus Video System

F. Mentors

G. Petya's Exams


A. Remove Duplicates

要求我们从右边开始保留数,我们可以考虑的就是用map来保存第一个出现的,然后倒着输出即可

void solve(){cin>>n;vector<int> a(n);for(auto&v:a) cin>>v;vector<int> ans;map<int,int> mp;for(int i=n-1;i>=0;i--){if(mp.count(a[i])) continue;ans.push_back(a[i]);mp[a[i]]++;} cout<<ans.size()<<endl;for(int i=ans.size()-1;i>=0;i--) cout<<ans[i]<<' ';cout<<endl;return ;
}

B. File Name

从字符中把三个以上的x删掉最多连续两个,明显的对于x我们使用双指针来维护即可

void solve(){cin>>n;string s; cin>>s;s=' '+s;int ans=0;for(int i=1;i<=n;i++){int j=i;if(s[j]=='x'){while(j<=n && s[j]=='x') j++;j--;ans+= max(0,j-i+1-2);i=j; }}cout<<ans<<endl;return ;
}

C. Letters

最为经典的前缀和加二分处理,注意我们找到比现在大于等于的然后减去前面的就好了

void solve(){cin>>n>>m;vector<LL> a(n+5);for(int i=1;i<=n;i++) cin>>a[i],a[i]+=a[i-1];while(m--){LL x; cin>>x;int l=1,r=n;while(l<r){int mid=l+r>>1;if(a[mid]>=x) r=mid;else l=mid+1;}cout<<l<<' '<<x-a[l-1]<<endl;}return ;
}

D. Almost Arithmetic Progression

题目考察的是等差数列的性质我们可以了解到等差数列固定了第一个数和公差整个也就固定了,也就是固定了第一个数和第二个数整个也就固定了,所以一共有3*3=9种操作次数,所以我们只要对1,2处理即可,考虑使用函数解决(重复的东西用函数美丽且好调试)

void solve(){cin>>n;vector<int> a(n+5),b(n+5);int ans=2*n+5;for(int i=1;i<=n;i++) cin>>a[i],b[i]=a[i];if(n==1||n==2) return cout<<0,void();auto change = [&](){int d=b[2]-b[1];int res=0;for(int i=3;i<=n;i++){if(b[i]-b[i-1]==d) continue;res++;if(b[i]-b[i-1]==d+1) b[i]--;else if(b[i]-b[i-1]==d-1) b[i]++;else return 2*n+5;}return res;};for(int i=-1;i<=1;i++)for(int j=-1;j<=1;j++){for(int k=1;k<=n;k++) b[k]=a[k];b[1]+=i,b[2]+=j;ans=min(ans,abs(i)+abs(j)+change());}cout<<(ans >2*n ? -1 : ans)<<endl;return ;
}

E. Bus Video System

我们可以多样的思考问题,整个过程一定是以恶搞波形图,最后一定是整体上升的一个过程,那么最大的不能大过容量,最小的不能小于0,所以我们就此维护最大值和最小值然后处理出初始的时候的上下限即可

LL t,n,m;void solve(){cin>>n>>m;LL Smax=0,Smin=m,now=0;while(n--){LL x; cin>>x;now+=x;Smax=max(Smax,now);Smin=min(Smin,now);}LL top = m-Smax;LL down = max(0ll - Smin,0ll);cout<<max(top-down+1,0ll)<<endl;return ;
}

F. Mentors

题目告诉我们关系不会重复不妨这样考虑如果我们从小到大按照能力排序然后对于每一个关系维护前面比他小的有口角的人数,按照他的排序减去有口角的即可,对于相同的数我们在口角中去掉,然后再考虑答案的时候用map来维护前面每一个能力出现的数量再减去即可

struct code{int x,id;bool operator<(const code&t)const{return x<t.x;}
}e[N];void solve(){cin>>n>>m;vector<int> w(n+1);for(int i=1;i<=n;i++){int x; cin>>x;w[i]=x;e[i]={x,i};}sort(e+1,e+1+n);vector<int> ton(n+5);map<int,int> same;while(m--){int a,b; cin>>a>>b;if(w[a]==w[b]) continue;if(w[a]>w[b]) swap(a,b);// 有能力的在后面ton[b]++;}vector<int> ans(n+5);for(int i=1;i<=n;i++){auto [x,id]=e[i];ans[id]=i-1-ton[id]-same[x];same[x]++;}for(int i=1;i<=n;i++) cout<<ans[i]<<' ';cout<<endl;return ;
}

G. Petya's Exams

简单贪心策略,我们肯定是谁先考试先处理谁他的前面一定是最多的可用空闲时间,然后从他的告诉考试时间考试处理,如果够了就退出,这是一个比较简单且明显的贪心策略,可以简单的证明是正确的

struct code{int id,d,test,need;bool operator<(const code&t)const{return test<t.test;}
}e[N];void solve(){cin>>n>>m;for(int i=1;i<=m;i++){int d,test,need; cin>>d>>test>>need;e[i]={i,d,test,need};}sort(e+1,e+1+m);vector<int> day(n+5);for(int i=1;i<=m;i++){auto [id,d,test,need]=e[i];day[test]=m+1;for(int i=d;i<=test;i++){if(day[i]) continue;day[i]=id;need--;if(!need) break;}if(need) return cout<<-1,void();}for(int i=1;i<=n;i++) cout<<day[i]<<' ';cout<<endl;return ;
}

这篇关于Codeforces Round 481 (Div. 3)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/669375

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There